## elastix 4.7

=== CMakeLists.txt ===
#---------------------------------------------------------------------
cmake_minimum_required( VERSION 2.8 )
cmake_policy( SET CMP0012 NEW )

#---------------------------------------------------------------------
project( elastix )

#---------------------------------------------------------------------
# Generate executable, static library or dynamic library.
mark_as_advanced( ELASTIX_BUILD_EXECUTABLE )
option( ELASTIX_BUILD_EXECUTABLE "Generate executable or library?" ON )

IF( NOT ELASTIX_BUILD_EXECUTABLE )
  ADD_DEFINITIONS( -D_ELASTIX_BUILD_LIBRARY )
  MARK_AS_ADVANCED( ELASTIX_BUILD_SHARED_LIBS )
  OPTION( ELASTIX_BUILD_SHARED_LIBS "Build shared libraries?" ON )
  IF( ELASTIX_BUILD_SHARED_LIBS )
    ADD_DEFINITIONS( -D_ELASTIX_BUILD_SHARED_LIBRARY )
  ENDIF()
ENDIF()

#---------------------------------------------------------------------
# Find ITK.
find_package( ITK REQUIRED )
include( ${ITK_USE_FILE} )

#---------------------------------------------------------------------
# Add the elastix source dir as an additional module path,
# so that CMake is able to find the FindPackage modules.
list( APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR} )

#---------------------------------------------------------------------
# Find CUDA.
mark_as_advanced( ELASTIX_USE_CUDA )
option( ELASTIX_USE_CUDA "Use CUDA enabled GPU" OFF )

if( ELASTIX_USE_CUDA )
  find_package( CUDA REQUIRED )

  mark_as_advanced( CUDA_BUILD_CUBIN )
  mark_as_advanced( CUDA_BUILD_EMULATION )
  mark_as_advanced( CUDA_VERBOSE_BUILD )
  mark_as_advanced( CUDA_SDK_ROOT_DIR )
endif()

#---------------------------------------------------------------------
# Find Eigen
mark_as_advanced( ELASTIX_USE_EIGEN )
option( ELASTIX_USE_EIGEN "Use Eigen library" OFF )

if( ELASTIX_USE_EIGEN )
  find_package( Eigen3 REQUIRED )
  include_directories( ${EIGEN3_INCLUDE_DIR} )
  add_definitions( -DELASTIX_USE_EIGEN )
endif()

#---------------------------------------------------------------------
# Find OpenMP
find_package( OpenMP )

if( OPENMP_FOUND )
  set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}" )
  set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}" )
  #  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}
  #  ${OpenMP_EXE_LINKER_FLAGS}")
  add_definitions( -DELASTIX_USE_OPENMP )
endif()

#----------------------------------------------------------------------
# Check for the SuiteSparse package
# We need to do that here, because the link_directories should be set
# before declaring any targets.

if( USE_PreconditionedGradientDescent )
 set( SUITESPARSE_BINARY_DIR "" CACHE PATH "Path to SuiteSparse" )
 set( SUITESPARSE_USE_FILE ${SUITESPARSE_BINARY_DIR}/UseSuiteSparse.cmake )
 if( EXISTS ${SUITESPARSE_USE_FILE} )
  include( ${SUITESPARSE_USE_FILE} )
 endif()
endif()

#---------------------------------------------------------------------
# Set single output directories for all executables and libraries.
# This makes it easier to create an elxUseFile.cmake, that users can
# include in their programs to borrow elastix functionality.

if( NOT LIBRARY_OUTPUT_PATH )
  set( LIBRARY_OUTPUT_PATH ${elastix_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all libraries." )
endif()

if( NOT EXECUTABLE_OUTPUT_PATH )
  set( EXECUTABLE_OUTPUT_PATH ${elastix_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all executables." )
endif()

# Mark these variables as advanced; their default value is usually fine
mark_as_advanced( LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH )

#---------------------------------------------------------------------
# Check if Mevis DicomTiff support is desired
mark_as_advanced( ELASTIX_USE_MEVISDICOMTIFF )
option( ELASTIX_USE_MEVISDICOMTIFF
  "Support MevisLab DicomTiff image format" OFF )

#---------------------------------------------------------------------
# Define cmake variable to define extra user component directories
# These directories will be added to the list of include directories
# and they will be searched for CMakeLists.txt files for further
# processing. In these directories, users may put code for their own
# components.

mark_as_advanced( ELASTIX_USER_COMPONENT_DIRS )
set( ELASTIX_USER_COMPONENT_DIRS "" CACHE PATH
  "directories with user defined elastix components" )

#---------------------------------------------------------------------
# elastix depends on some ITK settings

if( NOT ITKReview_LOADED )
  message( SEND_ERROR "Module_ITKReview has not been set to ON when compiling ITK. This option is mandatory for elastix to build.\nPlease recompile your ITK installation." )
endif()

#---------------------------------------------------------------------
# If IDE supports it, do use folder view.
# gcc automatically ignores it. VC Express does not support and gives
# annoying warnings when this option is turned on.
# VC pro does support it.
set( CMAKE_USE_FOLDERS ON CACHE INTERNAL "Use folder view in IDE" )
if( CMAKE_MAKE_PROGRAM MATCHES ".?VCExpress.?" )
  set( CMAKE_USE_FOLDERS OFF CACHE INTERNAL "Use folder view in IDE" )
endif()
set_property( GLOBAL PROPERTY USE_FOLDERS ${CMAKE_USE_FOLDERS} )

#---------------------------------------------------------------------
# Set default build type to Release, if none was specified
# Taken from ITK CMake list
if( NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES )
  message( STATUS "Setting build type to 'Release' as none was specified." )
  set( CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE )
  # Set the possible values of build type for cmake-gui
  set_property( CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo" )
endif()

#---------------------------------------------------------------------
# Include directories

set( elxCommon_INCLUDE_DIRECTORIES
  ${elastix_SOURCE_DIR}/Common
  ${elastix_SOURCE_DIR}/Common/CostFunctions
  ${elastix_SOURCE_DIR}/Common/CUDA
  ${elastix_SOURCE_DIR}/Common/ImageSamplers
  ${elastix_SOURCE_DIR}/Common/KNN
  ${elastix_SOURCE_DIR}/Common/KNN/ann_1.1/include
  ${elastix_SOURCE_DIR}/Common/LineSearchOptimizers
  ${elastix_SOURCE_DIR}/Common/ParameterFileParser
  ${elastix_SOURCE_DIR}/Common/Transforms
  ${elastix_SOURCE_DIR}/Common/xout
  ${elastix_SOURCE_DIR}/Common/MevisDicomTiff
)

set( elxCore_INCLUDE_DIRECTORIES
  ${elastix_SOURCE_DIR}/Core
  ${elastix_SOURCE_DIR}/Core/Install
  ${elastix_SOURCE_DIR}/Core/Kernel
  ${elastix_SOURCE_DIR}/Core/ComponentBaseClasses
  ${elastix_SOURCE_DIR}/Core/Configuration
  ${elastix_SOURCE_DIR}/Core/Main
)

set( elxComponents_INCLUDE_DIRECTORIES
  ${elastix_SOURCE_DIR}/Components/FixedImagePyramids
  ${elastix_SOURCE_DIR}/Components/ImageSamplers
  ${elastix_SOURCE_DIR}/Components/Interpolators
  ${elastix_SOURCE_DIR}/Components/Metrics
  ${elastix_SOURCE_DIR}/Components/MovingImagePyramids
  ${elastix_SOURCE_DIR}/Components/Optimizers
  ${elastix_SOURCE_DIR}/Components/Registrations
  ${elastix_SOURCE_DIR}/Components/ResampleInterpolators
  ${elastix_SOURCE_DIR}/Components/Resamplers
  ${elastix_SOURCE_DIR}/Components/Transforms
)

set( elxINCLUDE_DIRECTORIES
  ${elxCommon_INCLUDE_DIRECTORIES}
  ${elxCore_INCLUDE_DIRECTORIES}
  ${elxComponents_INCLUDE_DIRECTORIES}
  ${elastix_BINARY_DIR}
  ${ELASTIX_USER_COMPONENT_DIRS}
)

include_directories( ${elxINCLUDE_DIRECTORIES} )

#---------------------------------------------------------------------
# Microsoft specific items

if( MSVC )
  # Kill the anoying MS VS warning about non-safe functions.
  # They hide real warnings.
  add_definitions(
    /D_SCL_SECURE_NO_DEPRECATE
    /D_CRT_SECURE_NO_DEPRECATE
    /D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
  )

  # Increases address capacity
  if ( WIN32 )
    set( CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /bigobj" )
    set( CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /bigobj" )
    set( CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /bigobj" )
  endif()
endif()

#---------------------------------------------------------------------
# Process the sub-directories

# Common dir: code that is neither related to the core of elastix or
# to specific components.
add_subdirectory( Common )

# Components: the registration components such as metrics, transforms,
# optimizers, etc.
add_subdirectory( Components )

# Core dir: code that takes care of starting elastix, loading
# components, definitions of macros etc.
add_subdirectory( Core )

#---------------------------------------------------------------------
# Configure the examples

set( ELASTIX_DOX_DIR  ${elastix_SOURCE_DIR}/../dox )
set( ELASTIX_HELP_DIR ${elastix_SOURCE_DIR}/../help CACHE PATH
  "path to the doxygen generated help files and the examples" )

# Copy the examples to the help directory

if( WIN32 )
  configure_file(
    ${ELASTIX_DOX_DIR}/example.bat
    ${ELASTIX_HELP_DIR}/example.bat
    COPYONLY )
else()
  configure_file(
    ${ELASTIX_DOX_DIR}/example
    ${ELASTIX_HELP_DIR}/example
    COPYONLY )
endif()

make_directory( ${ELASTIX_HELP_DIR}/exampleinput )
make_directory( ${ELASTIX_HELP_DIR}/exampleoutput )

set( ELX_EXAMPLEINPUTFILES
  fixed.mhd
  fixed.raw
  mask_fixed.mhd
  mask_fixed.raw
  mask_moving.mhd
  mask_moving.raw
  moving.mhd
  moving.raw
  parameters_Affine.txt
  parameters_BSpline.txt
  parameters_Rigid.txt
  parameters_Translation.txt
  solution_deformedmovingimage.mhd
  solution_deformedmovingimage.raw
)

foreach( ELX_EXAMPLEINPUTFILE ${ELX_EXAMPLEINPUTFILES} )
  configure_file(
    ${ELASTIX_DOX_DIR}/exampleinput/${ELX_EXAMPLEINPUTFILE}
    ${ELASTIX_HELP_DIR}/exampleinput/${ELX_EXAMPLEINPUTFILE}
    COPYONLY )
endforeach()

#---------------------------------------------------------------------
# Get version information.

# Get the version number of elastix
file( STRINGS ${elastix_SOURCE_DIR}/Core/Install/elxBaseComponent.h
  ELASTIX_VERSION REGEX "\(#define\ __ELASTIX_VERSION\)" )
string( SUBSTRING ${ELASTIX_VERSION} 26 3 ELASTIX_VERSION )

# Split version in major minor. Assuming no patch number, just x.y
string( REGEX MATCH "[0-9]+" ELASTIX_VERSION_MAJOR "${ELASTIX_VERSION}" )
string( REGEX REPLACE "([0-9]+)\\." "" ELASTIX_VERSION_MINOR "${ELASTIX_VERSION}" )

#---------------------------------------------------------------------
# Configure the doxygen-configuration

find_package( Doxygen QUIET )
string( COMPARE NOTEQUAL ${DOXYGEN} "DOXYGEN-NOTFOUND" Doxygen_FOUND )

if( Doxygen_FOUND )

  # Set the path to the doxygen configuration source
  set( ELASTIX_DOXYGEN_DIR ${ELASTIX_DOX_DIR}/doxygen )

  # Get the version number of doxygen
  EXEC_PROGRAM( ${DOXYGEN} ARGS "--version" OUTPUT_VARIABLE ELASTIX_DOXYGEN_VERSION )

  # Get date
  if( UNIX OR CYGWIN )
    EXEC_PROGRAM( "date '+%d-%m-%Y'" OUTPUT_VARIABLE ELASTIX_DOXYGEN_DATE )
  endif()
  if( WIN32 )
    if( NOT CYGWIN )
      EXECUTE_PROCESS( COMMAND "${ELASTIX_DOXYGEN_DIR}/doxdate.bat"
        OUTPUT_VARIABLE ELASTIX_DOXYGEN_DATETEMP )
      string( REPLACE "/" "-" ELASTIX_DOXYGEN_DATE ${ELASTIX_DOXYGEN_DATETEMP} )
    endif()
  endif()

  # Configure the doxygen configuration
  configure_file(
    ${ELASTIX_DOXYGEN_DIR}/doxyfile.in
    ${ELASTIX_HELP_DIR}/doxyfile.out @ONLY )

  # Configure the footer of the help website.
  configure_file(
    ${ELASTIX_DOXYGEN_DIR}/DoxygenFooter.html.in
    ${ELASTIX_HELP_DIR}/DoxygenFooter.html @ONLY )

  # Configure the MainPage.dox
  configure_file(
    ${ELASTIX_DOXYGEN_DIR}/MainPage.dox.in
    ${ELASTIX_HELP_DIR}/MainPage.dox @ONLY )

endif()

#---------------------------------------------------------------------
# Testing

set( ELASTIX_BUILD_TESTING OFF CACHE BOOL
  "Perform some tests on basic functionality of elastix." )
if( ELASTIX_BUILD_TESTING )
  enable_testing()
  add_subdirectory( Testing )
  include( CTest )
endif()

#---------------------------------------------------------------------
# Packaging

mark_as_advanced( ELASTIX_ENABLE_PACKAGER )
option( ELASTIX_ENABLE_PACKAGER "Enable elastix packager using CPack" OFF )

=== Common/CMakeLists.txt ===
#---------------------------------------------------------------------
PROJECT( elxCommon )

#---------------------------------------------------------------------
# Sub-projects.

ADD_SUBDIRECTORY( ParameterFileParser )
ADD_SUBDIRECTORY( xout )

IF( USE_KNNGraphAlphaMutualInformationMetric )
  ADD_SUBDIRECTORY( KNN )
ENDIF()

ADD_SUBDIRECTORY( MevisDicomTiff )

IF( ELASTIX_USE_CUDA )
  ADD_SUBDIRECTORY( CUDA )
ENDIF()

#---------------------------------------------------------------------
# Define lists of files in the subdirectories.

SET( CommonFiles
  elxTimer.cxx
  elxTimer.h
  itkAdvancedLinearInterpolateImageFunction.h
  itkAdvancedLinearInterpolateImageFunction.hxx
  itkAdvancedRayCastInterpolateImageFunction.h
  itkAdvancedRayCastInterpolateImageFunction.hxx
  itkGenericMultiResolutionPyramidImageFilter.h
  itkGenericMultiResolutionPyramidImageFilter.hxx
  itkImageFileCastWriter.h
  itkImageFileCastWriter.hxx
  itkMeshFileReaderBase.h
  itkMeshFileReaderBase.hxx
  itkMultiResolutionGaussianSmoothingPyramidImageFilter.h
  itkMultiResolutionGaussianSmoothingPyramidImageFilter.hxx
  itkMultiResolutionImageRegistrationMethod2.h
  itkMultiResolutionImageRegistrationMethod2.hxx
  itkMultiResolutionShrinkPyramidImageFilter.h
  itkMultiResolutionShrinkPyramidImageFilter.hxx
  itkNDImageBase.h
  itkNDImageTemplate.h
  itkNDImageTemplate.hxx
  itkScaledSingleValuedNonLinearOptimizer.cxx
  itkScaledSingleValuedNonLinearOptimizer.h
  itkTransformixInputPointFileReader.h
  itkTransformixInputPointFileReader.hxx
)

SET( MaskFiles
  itkImageMaskSpatialObject2.h
  itkImageMaskSpatialObject2.hxx
  itkImageSpatialObject2.h
  itkImageSpatialObject2.hxx
  itkErodeMaskImageFilter.h
  itkErodeMaskImageFilter.hxx
  itkParabolicErodeDilateImageFilter.h
  itkParabolicErodeDilateImageFilter.hxx
  itkParabolicErodeImageFilter.h
  itkParabolicMorphUtils.h
)

SET( CostFunctionFiles
  CostFunctions/itkAdvancedImageToImageMetric.h
  CostFunctions/itkAdvancedImageToImageMetric.hxx
  CostFunctions/itkExponentialLimiterFunction.h
  CostFunctions/itkExponentialLimiterFunction.hxx
  CostFunctions/itkHardLimiterFunction.h
  CostFunctions/itkHardLimiterFunction.hxx
  CostFunctions/itkImageToImageMetricWithFeatures.h
  CostFunctions/itkImageToImageMetricWithFeatures.hxx
  CostFunctions/itkLimiterFunctionBase.h
  CostFunctions/itkMultiInputImageToImageMetricBase.h
  CostFunctions/itkMultiInputImageToImageMetricBase.hxx
  CostFunctions/itkParzenWindowHistogramImageToImageMetric.h
  CostFunctions/itkParzenWindowHistogramImageToImageMetric.hxx
  CostFunctions/itkScaledSingleValuedCostFunction.cxx
  CostFunctions/itkScaledSingleValuedCostFunction.h
  CostFunctions/itkSingleValuedPointSetToPointSetMetric.h
  CostFunctions/itkSingleValuedPointSetToPointSetMetric.hxx
  CostFunctions/itkTransformPenaltyTerm.h
  CostFunctions/itkTransformPenaltyTerm.hxx
)

SET( TransformFiles
  Transforms/itkAdvancedBSplineDeformableTransformBase.h
  Transforms/itkAdvancedBSplineDeformableTransformBase.hxx
  Transforms/itkAdvancedBSplineDeformableTransform.h
  Transforms/itkAdvancedBSplineDeformableTransform.hxx
  Transforms/itkAdvancedCombinationTransform.h
  Transforms/itkAdvancedCombinationTransform.hxx
  Transforms/itkAdvancedIdentityTransform.h
  Transforms/itkAdvancedMatrixOffsetTransformBase.h
  Transforms/itkAdvancedMatrixOffsetTransformBase.hxx
  Transforms/itkAdvancedRigid2DTransform.h
  Transforms/itkAdvancedRigid2DTransform.hxx
  Transforms/itkAdvancedRigid3DTransform.h
  Transforms/itkAdvancedRigid3DTransform.hxx
  Transforms/itkAdvancedTransform.h
  Transforms/itkAdvancedTransform.hxx
  Transforms/itkBSplineInterpolationDerivativeWeightFunction.h
  Transforms/itkBSplineInterpolationDerivativeWeightFunction.hxx
  Transforms/itkBSplineInterpolationSecondOrderDerivativeWeightFunction.h
  Transforms/itkBSplineInterpolationSecondOrderDerivativeWeightFunction.hxx
  Transforms/itkBSplineInterpolationWeightFunction2.h
  Transforms/itkBSplineInterpolationWeightFunction2.hxx
  Transforms/itkBSplineInterpolationWeightFunctionBase.h
  Transforms/itkBSplineInterpolationWeightFunctionBase.hxx
  #Transforms/itkBSplineKernelFunction2.h
  #Transforms/itkBSplineSecondOrderDerivativeKernelFunction.h
  Transforms/itkBSplineSecondOrderDerivativeKernelFunction2.h
  Transforms/itkTransformToDeterminantOfSpatialJacobianSource.h
  Transforms/itkTransformToDeterminantOfSpatialJacobianSource.hxx
  Transforms/itkTransformToSpatialJacobianSource.h
  Transforms/itkTransformToSpatialJacobianSource.hxx
  Transforms/itkGridScheduleComputer.h
  Transforms/itkGridScheduleComputer.hxx
  Transforms/itkUpsampleBSplineParametersFilter.h
  Transforms/itkUpsampleBSplineParametersFilter.hxx
)

SET( LineSearchOptimizersFiles
  LineSearchOptimizers/itkMoreThuenteLineSearchOptimizer.h
  LineSearchOptimizers/itkMoreThuenteLineSearchOptimizer.cxx
  LineSearchOptimizers/itkLineSearchOptimizer.h
  LineSearchOptimizers/itkLineSearchOptimizer.cxx
)

SET( ImageSamplersFiles
  ImageSamplers/itkImageFullSampler.h
  ImageSamplers/itkImageFullSampler.hxx
  ImageSamplers/itkImageGridSampler.h
  ImageSamplers/itkImageGridSampler.hxx
  ImageSamplers/itkImageRandomCoordinateSampler.h
  ImageSamplers/itkImageRandomCoordinateSampler.hxx
  ImageSamplers/itkImageRandomSampler.h
  ImageSamplers/itkImageRandomSampler.hxx
  ImageSamplers/itkImageRandomSamplerBase.h
  ImageSamplers/itkImageRandomSamplerSparseMask.h
  ImageSamplers/itkImageRandomSamplerSparseMask.hxx
  ImageSamplers/itkImageSample.h
  ImageSamplers/itkImageSamplerBase.h
  ImageSamplers/itkImageSamplerBase.hxx
  ImageSamplers/itkImageToVectorContainerFilter.h
  ImageSamplers/itkImageToVectorContainerFilter.hxx
  ImageSamplers/itkMultiInputImageRandomCoordinateSampler.h
  ImageSamplers/itkMultiInputImageRandomCoordinateSampler.hxx
  ImageSamplers/itkVectorContainerSource.h
  ImageSamplers/itkVectorContainerSource.hxx
  ImageSamplers/itkVectorDataContainer.h
  ImageSamplers/itkVectorDataContainer.hxx
)

#---------------------------------------------------------------------
# Construct source groups for nice visualisation in Visual Studio.

SOURCE_GROUP( "Masks" FILES ${MaskFiles} )
SOURCE_GROUP( "CostFunctions" FILES ${CostFunctionFiles} )
SOURCE_GROUP( "Transforms" FILES ${TransformFiles} )
SOURCE_GROUP( "LineSearchOptimizers" FILES ${LineSearchOptimizersFiles} )
SOURCE_GROUP( "ImageSamplers" FILES ${ImageSamplersFiles} )

#---------------------------------------------------------------------
# Create the elxCommon library.

ADD_LIBRARY( elxCommon
  ${MaskFiles}
  ${CommonFiles}
  ${CostFunctionFiles}
  ${TransformFiles}
  ${LineSearchOptimizersFiles}
  ${ImageSamplersFiles}
)

#---------------------------------------------------------------------
# Link against other libraries.

IF( UNIX AND NOT APPLE )
  TARGET_LINK_LIBRARIES( elxCommon
    ${ITK_LIBRARIES}
    rt # Needed for elxTimer, clock_gettime()
  )
ELSE()
  TARGET_LINK_LIBRARIES( elxCommon
    ${ITK_LIBRARIES}
  )
ENDIF()

=== Components/CMakeLists.txt ===
#---------------------------------------------------------------------
# Sub project name

PROJECT( elxComponents )

#---------------------------------------------------------------------
# Set the libraries to be linked.

# Linux gave an error, if param was linked. This was only
# when we still used .dll's. I'm not sure if it will still
# give an error, but as long as linux does not complain
# about the missing param, just leave it out.
IF( UNIX )
  IF ( NOT APPLE )
    SET( elxLinkLibs
      xoutlib
      elxCommon
      elxCore
      ${ITK_LIBRARIES} )
  ENDIF()
ENDIF()

# Interestingly, visual c++ and MAC-GCC do need param
IF( WIN32 OR APPLE )
  SET( elxLinkLibs
    param
    xoutlib
    elxCommon
    elxCore
    ${ITK_LIBRARIES} )
ENDIF()

#--------------------------------------------------------------------
# Prepare elxInstallComponentFunctionDeclarations.h and
# elxInstallComponentFunctionCalls.h
# In the ADD_ELXCOMPONENT macro a line is added
#

SET( InstallFunctionDeclarationFile
  ${elastix_BINARY_DIR}/elxInstallComponentFunctionDeclarations.h )
SET( InstallFunctionCallFile
  ${elastix_BINARY_DIR}/elxInstallComponentFunctionCalls.h )

FILE( WRITE ${InstallFunctionDeclarationFile}
  "\n" "//This file is generated by CMake. Do not edit manually!\n\n" )
FILE( WRITE ${InstallFunctionCallFile}
  "\n" "//This file is generated by CMake. Do not edit manually!\n\n" )


#---------------------------------------------------------------------
# Macros that simplify the addition (and removal) of elx-components
#
# Usage:
# ADD_ELXCOMPONENT( <name_of_lib> <list_of_source_and_header_files> )
#
# The name_of_lib should be equal to the name of the elx class,
# which also should be the name used in the elxInstallMacro, in the
# the .cxx file of the component.
#
# The REMOVE_ELXCOMPONENT is in some cases useful, if you want to
# skip building the component in case some other cmake setting is not
# correct. Most users will not need to invoke this macro though.
#
# Usage:
# REMOVE_ELXCOMPONENT( <name_of_lib> )
#
INCLUDE( CMakeDependentOption )

MACRO( REMOVE_ELXCOMPONENT name )
  # remove lib from link list
  IF( DEFINED AllComponentLibs )
    SET( dummy ${AllComponentLibs} )
    IF( NOT "${dummy}" STREQUAL "")
      LIST( REMOVE_ITEM dummy ${name} )
    ENDIF()
  ELSE()
    SET( dummy "" )
  ENDIF()
  SET( AllComponentLibs ${dummy} CACHE INTERNAL "All component libraries for elastix/transformix"  )
ENDMACRO( REMOVE_ELXCOMPONENT )

MACRO( ADD_ELXCOMPONENT name )

  # Compile this component or not
  SET( defaultValue ON )
  IF( ${ARGV1} STREQUAL "OFF" )
    SET( defaultValue OFF )
  ENDIF()
  MARK_AS_ADVANCED( USE_${name} )
  SET( USE_${name} ${defaultValue} CACHE BOOL "Compile this component")

  # If USE_ALL_COMPONENTS is turned ON, we make a backup of the
  # current value, and force the use_var to ON. If USE_ALL_COMPONENTS
  # is OFF, and there is a backup, set the use_var to the backed-up
  # value and remove the backup; otherwise, leave the use_var to its
  # current (default or user-specified) value.
  IF( USE_ALL_COMPONENTS )
    # make backup
    IF( NOT DEFINED USE_${name}_BACKUP )
      IF( USE_${name} )
        SET( USE_${name}_BACKUP ON CACHE INTERNAL "Backup of USE_var" FORCE )
      ELSE()
        SET( USE_${name}_BACKUP OFF CACHE INTERNAL "Backup of USE_var" FORCE )
      ENDIF()
    ENDIF()
    # turn use_var to on;
    SET( USE_${name} ON CACHE BOOL "Compile this component" FORCE )
  ELSE()
    # if there is a backup, set the use_var to the backed-up value
    # and remove the backup.
    IF( DEFINED USE_${name}_BACKUP )
      # this unset command is important; it makes sure the use_var is reset
      UNSET( USE_${name} CACHE )
      IF( USE_${name}_BACKUP )
        SET( USE_${name} ON CACHE BOOL "Compile this component")
      ELSE()
        SET( USE_${name} OFF CACHE BOOL "Compile this component")
      ENDIF()
      UNSET( USE_${name}_BACKUP CACHE )
    ENDIF()
  ENDIF()

  IF( USE_${name} )
    # Create the list of files which create the library
    SET( filelist ${ARGN} )
    LIST( REMOVE_ITEM filelist "ON" "OFF" )

    # Create project and library
    PROJECT( ${name} )
    ADD_LIBRARY( ${name} STATIC ${filelist} )
    TARGET_LINK_LIBRARIES( ${name} ${elxLinkLibs} )

    # Group in IDE's like Visual Studio
    STRING( REGEX MATCH "[a-zA-Z]+" comp_group ${relative_path_to_comp} )
    SET_PROPERTY( TARGET ${name} PROPERTY FOLDER ${comp_group} )

    # Update AllComponentLibs, while avoiding duplicates:
    IF( DEFINED AllComponentLibs )
      SET( dummy ${AllComponentLibs} )
      IF( NOT "${dummy}" STREQUAL "")
        LIST( REMOVE_ITEM dummy ${name} )
      ENDIF()
      SET( dummy ${dummy} ${name} )
    ELSE()
      SET( dummy ${name} )
    ENDIF()
    SET( AllComponentLibs ${dummy} CACHE INTERNAL "All component libraries for elastix/transformix" )

    # Write lines to two files
    FILE( APPEND ${InstallFunctionDeclarationFile}
      "elxInstallComponentFunctionDeclarationMacro( " ${name} " );\n\n" )
    FILE( APPEND ${InstallFunctionCallFile}
      "elxInstallComponentFunctionCallMacro( " ${name} " );\n\n" )

  ELSE( USE_${name} )
    # Remove from link list
    REMOVE_ELXCOMPONENT( ${name} )
  ENDIF()

ENDMACRO( ADD_ELXCOMPONENT )

#---------------------------------------------------------------------
# Option to turn on all components by default
MARK_AS_ADVANCED( USE_ALL_COMPONENTS )
SET( USE_ALL_COMPONENTS OFF CACHE BOOL "Compile all components" )


#---------------------------------------------------------------------
# Search for all components in the elastix source directory
#

# Initialize the list of link libs.
set( AllComponentLibs "" CACHE INTERNAL "All component libraries for elastix/transformix"  )

file( GLOB_RECURSE ListOfComponents "*/CMakeLists.txt" )

foreach( component ${ListOfComponents} )
  get_filename_component( path_to_comp ${component} PATH )
  # Make the path relative to the elxComponents_SOURCE_DIR
  string( REGEX REPLACE "${elxComponents_SOURCE_DIR}/" "" relative_path_to_comp ${path_to_comp} )
  add_subdirectory( ${relative_path_to_comp} )
endforeach()


#----------------------------------------------------------------------
# Search for user components
# These are components defined in external directories
# outside elastix, defined by the user.

foreach( userComponentDir ${ELASTIX_USER_COMPONENT_DIRS} )

  message( STATUS "Searching for user components in: ${userComponentDir}" )
  file( GLOB_RECURSE listOfUserComponents "${userComponentDir}/CMakeLists.txt" )

  foreach( userComponent ${listOfUserComponents} )

    # Get the path name
    get_filename_component( path_to_comp ${userComponent} PATH )

    # Read project name from cmakelists.txt
    # Find the first line that has the following structure:
    # ADD_ELXCOMPONENT( projectname [....]
    # spaces before/after/inbetween are allowed.
    # ADD_ELXCOMPONENT does not have to be capitalized.
    # Commented lines (where the first nonwhite character is a #) are ignored.
    file( STRINGS ${userComponent} addElxComponentLine LIMIT_COUNT 1 REGEX
      "^[ \t]*[Aa][Dd][Dd]_[Ee][Ll][Xx][Cc][Oo][Mm][Pp][Oo][Nn][Ee][Nn][Tt][ \t]*[(][ \t]*[^ #\t()]+" )

    # Extract the projectname.
    string( REGEX REPLACE
      "^[ \t]*[Aa][Dd][Dd]_[Ee][Ll][Xx][Cc][Oo][Mm][Pp][Oo][Nn][Ee][Nn][Tt][ \t]*[(][ \t]*([^ #\t()]+).*"
      "\\1" componentName "${addElxComponentLine}")

    # Process the current component
    if( NOT "${componentName}" STREQUAL "" )
      # For non-subdirectories, the binarydir should be specified.
      # We use the name of the component for that.
      set( binaryDir "${elastix_BINARY_DIR}/UserComponents/${componentName}" )

      # Add. Make sure that the path relative to the ELASTIX_USER_COMPONENT_DIRS is set,
      # so that the component ends up in the correct source group.
      string( REGEX REPLACE "${ELASTIX_USER_COMPONENT_DIRS}/" "" relative_path_to_comp ${path_to_comp} )
      add_subdirectory( ${path_to_comp} ${binaryDir} )

      message( STATUS "Found user component: ${relative_path_to_comp}" )
    else()
      message( STATUS "No user component definition found in: ${userComponent}" )
    endif()

  endforeach()
endforeach()

=== Core/CMakeLists.txt ===
#---------------------------------------------------------------------
project( elxCore )

#---------------------------------------------------------------------
# Define lists of files in the subdirectories.

set( KernelFilesForExecutables
  Kernel/elxElastixMain.cxx
  Kernel/elxElastixMain.h
  Kernel/elxTransformixMain.cxx
  Kernel/elxTransformixMain.h
)

set( KernelFilesForComponents
  Kernel/elxElastixBase.cxx
  Kernel/elxElastixBase.h
  Kernel/elxElastixTemplate.h
  Kernel/elxElastixTemplate.hxx
)

set( InstallFilesForExecutables
  Install/elxComponentLoader.cxx
  Install/elxComponentLoader.h
)

set( InstallFilesForComponents
  Install/elxComponentDatabase.cxx
  Install/elxComponentDatabase.h
  Install/elxBaseComponent.h
  Install/elxBaseComponentSE.h
  Install/elxBaseComponentSE.hxx
  Install/elxInstallAllComponents.h
  Install/elxInstallFunctions.h
  Install/elxMacro.h
  Install/elxIncludes.h
)

set( ConfigurationFiles
  Configuration/elxConfiguration.cxx
  Configuration/elxConfiguration.h
)

set( ComponentBaseClassFiles
  ComponentBaseClasses/elxFixedImagePyramidBase.h
  ComponentBaseClasses/elxImageSamplerBase.h
  ComponentBaseClasses/elxInterpolatorBase.h
  ComponentBaseClasses/elxMetricBase.h
  ComponentBaseClasses/elxMovingImagePyramidBase.h
  ComponentBaseClasses/elxOptimizerBase.h
  ComponentBaseClasses/elxRegistrationBase.h
  ComponentBaseClasses/elxResampleInterpolatorBase.h
  ComponentBaseClasses/elxResamplerBase.h
  ComponentBaseClasses/elxTransformBase.h
  ComponentBaseClasses/elxFixedImagePyramidBase.hxx
  ComponentBaseClasses/elxImageSamplerBase.hxx
  ComponentBaseClasses/elxInterpolatorBase.hxx
  ComponentBaseClasses/elxMetricBase.hxx
  ComponentBaseClasses/elxMovingImagePyramidBase.hxx
  ComponentBaseClasses/elxOptimizerBase.hxx
  ComponentBaseClasses/elxRegistrationBase.hxx
  ComponentBaseClasses/elxResampleInterpolatorBase.hxx
  ComponentBaseClasses/elxResamplerBase.hxx
  ComponentBaseClasses/elxTransformBase.hxx
)

set( ProgressCommandFiles
  elxProgressCommand.cxx
  elxProgressCommand.h
)

#---------------------------------------------------------------------
# Construct source groups for nice visualisation in Visual Studio.

source_group( "Install" FILES
  ${InstallFilesForComponents}
  ${InstallFilesForExecutables}
)

source_group( "Kernel" FILES
  ${KernelFilesForComponents}
  ${KernelFilesForExecutables}
)

source_group( "Configuration" FILES ${ConfigurationFiles} )
source_group( "ComponentBaseClasses" FILES ${ComponentBaseClassFiles} )
source_group( "ProgressCommand" FILES ${ProgressCommandFiles} )

#---------------------------------------------------------------------
# Create the elxCore library.

add_library( elxCore
  ${KernelFilesForComponents}
  ${InstallFilesForComponents}
  ${ConfigurationFiles}
  ${ComponentBaseClassFiles}
  ${ProgressCommandFiles}
)

#---------------------------------------------------------------------
# Link against other libraries.

target_link_libraries( elxCore
  elxCommon
  xoutlib
  param # Needed for elxConfiguration
  #  ${ITK_LIBRARIES}
)

#---------------------------------------------------------------------
# Define the mevis dcm tiff lib to which we should link.
set( mevisdcmtifflib mevisdcmtiff )

#---------------------------------------------------------------------
# Create the elastix executable or library.
IF( ELASTIX_BUILD_EXECUTABLE )
  ADD_EXECUTABLE( elastix
    Main/elastix.cxx
    Main/elastix.h
    Kernel/elxElastixMain.cxx
    Kernel/elxElastixMain.h
    ${InstallFilesForExecutables}
  )
ELSE(ELASTIX_BUILD_EXECUTABLE)
  IF( ELASTIX_BUILD_SHARED_LIBS )
    ADD_LIBRARY( elastix SHARED
      Main/elastixlib.cxx
      Main/elastixlib.h
      Kernel/elxElastixMain.cxx
      Kernel/elxElastixMain.h
      ${InstallFilesForExecutables}
    )
  ELSE(ELASTIX_BUILD_SHARED_LIBS)
    ADD_LIBRARY( elastix STATIC
      Main/elastixlib.cxx
      Main/elastixlib.h
      Kernel/elxElastixMain.cxx
      Kernel/elxElastixMain.h
      ${InstallFilesForExecutables}
    )
  ENDIF(ELASTIX_BUILD_SHARED_LIBS)
ENDIF(ELASTIX_BUILD_EXECUTABLE)

#---------------------------------------------------------------------
# Create the transformix executable.

IF( ELASTIX_BUILD_EXECUTABLE )
  ADD_EXECUTABLE( transformix
    Main/transformix.cxx
    Main/transformix.h
    Kernel/elxElastixMain.cxx
    Kernel/elxElastixMain.h
    Kernel/elxTransformixMain.cxx
    Kernel/elxTransformixMain.h
    ${InstallFilesForExecutables}
  )
ELSE()
  IF( ELASTIX_BUILD_SHARED_LIBS )
    ADD_LIBRARY( transformix SHARED
      Main/transformixlib.cxx
      Main/transformixlib.h
      Kernel/elxElastixMain.cxx
      Kernel/elxElastixMain.h
      Kernel/elxTransformixMain.cxx
      Kernel/elxTransformixMain.h
      ${InstallFilesForExecutables}
    )
  ELSE( ELASTIX_BUILD_SHARED_LIBS )
    ADD_LIBRARY( transformix STATIC
      Main/transformixlib.cxx
      Main/transformixlib.h
      Kernel/elxElastixMain.cxx
      Kernel/elxElastixMain.h
      Kernel/elxTransformixMain.cxx
      Kernel/elxTransformixMain.h
      ${InstallFilesForExecutables}
    )
  ENDIF( ELASTIX_BUILD_SHARED_LIBS )
ENDIF()

#---------------------------------------------------------------------
# Link elastix against other libraries.

target_link_libraries( elastix
  param
  xoutlib
  elxCommon
  elxCore
  ${mevisdcmtifflib}
  ${AllComponentLibs}
  ${ITK_LIBRARIES}
)

#---------------------------------------------------------------------
# Link transformix against other libraries.

target_link_libraries( transformix
  param
  xoutlib
  elxCommon
  elxCore
  ${mevisdcmtifflib}
  ${AllComponentLibs}
  ${ITK_LIBRARIES}
)

if( MSVC )
  # NOTE: that linker /INCREMENTAL:NO flag makes it impossible to use
  # Debug breakpoints in Visual Studio 10.0. It is probably the Visual Studio 10.0 bug.
  # Or you have to recompile ITK with the same flag in Debug as well.
  # Or it has something to do with building it with IncrediBuild where this flag is not welcome for PDB files.
  # Therefore we are going to set it only for Visual Studio 9.0 (2008)
  if( MSVC90 OR MSVC91 )
    set( CMAKE_EXE_LINKER_FLAGS_DEBUG "/INCREMENTAL:NO" )
  endif()
endif()

#---------------------------------------------------------------------
# Define the install directory for elastix and transformix.

if( WIN32 )
  if( ELASTIX_BUILD_EXECUTABLE )
    install( TARGETS elastix transformix
      RUNTIME DESTINATION . )
      #COMPONENT core )
  ELSE( ELASTIX_BUILD_EXECUTABLE )
    # transformix is not implemented as library yet
    INSTALL( TARGETS elastix transformix
      RUNTIME DESTINATION .
      ARCHIVE DESTINATION . )
  ENDIF( ELASTIX_BUILD_EXECUTABLE )
ELSE( WIN32 )
  # Tell the executables where to find the required .so files.
  SET_TARGET_PROPERTIES( elastix transformix
    PROPERTIES INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib:${ITK_DIR}" )
  # Put executables in bin and libraries in lib.
  install( TARGETS elastix transformix
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION bin
    ARCHIVE DESTINATION bin)
    #COMPONENT core )
ENDIF( WIN32 )

#---------------------------------------------------------------------
# The Core/Install directory contains a CMakeLists file for
# defining the elastix compilation types.

add_subdirectory( Install )

=== Testing/CMakeLists.txt ===
#---------------------------------------------------------------------
Project( elxTesting )

# Set some directories
set( TestDataDir ${elastix_SOURCE_DIR}/Testing/Data )
set( TestBaselineDir ${elastix_SOURCE_DIR}/Testing/Baselines )
set( TestOutputDir ${elastix_BINARY_DIR}/Testing )

#---------------------------------------------------------------------
# Python is used by some tests
find_program( python_executable python
  HINTS "C:/Program Files/Python2.7" "C:/Program Files/python3.3" )
if( NOT python_executable )
  message( WARNING "WARNING: python not found! Some test results can not be evaluated." )
endif()

#---------------------------------------------------------------------
# Add macro to decide if mevisdicomtiff should be tested
if( ELASTIX_USE_MEVISDICOMTIFF )
  add_definitions( -D_ELASTIX_USE_MEVISDICOMTIFF )
endif()
set( mevisdcmtifflib mevisdcmtiff )


#---------------------------------------------------------------------
# Macro that simplifies the addition of elastix tests
#
# Usage:
# elx_add_test( <name_of_test> )
#
# We assume here that the name of the source which includes the main is:
#   "itk"name_of_test".cxx".
#

macro( elx_add_test name )
  # Define some helper variables.
  set( ELXTEST_EXECUTABLE_NAME itk${name} )
  set( ELXTEST_SOURCE_NAME itk${name}.cxx )
  set( ELXTEST_TEST_NAME ${name} )

  # Create the test executable.
  add_executable( ${ELXTEST_EXECUTABLE_NAME} ${ELXTEST_SOURCE_NAME} )

  # Link against other libraries.
  target_link_libraries( ${ELXTEST_EXECUTABLE_NAME}
    elxCommon # needed for elxTimer
    ${ITK_LIBRARIES}
    ${mevisdcmtifflib}
  )

  # Group in IDE's like Visual Studio
  set_property( TARGET ${ELXTEST_EXECUTABLE_NAME} PROPERTY FOLDER "tests" )

  # Add the test.
  add_test( NAME ${ELXTEST_TEST_NAME}
    COMMAND ${EXECUTABLE_OUTPUT_PATH}/${ELXTEST_EXECUTABLE_NAME} ${ARGN} )
endmacro()

#---------------------------------------------------------------------
# Macro that simplifies the addition of transformix tests
#
# Usage:
# trx_add_test( <name_of_test> <transformix_commandline_arguments> )
#
# The macro runs transformix with the provided commandline arguments.
#

macro( trx_add_test name )
  # Create output directory
  set( testname transformix_run_${name} )
  set( output_dir ${TestOutputDir}/${testname} )
  file( MAKE_DIRECTORY ${output_dir} )
  
  # Define some helper variables.
  set( TRXTEST_EXECUTABLE_NAME transformix )
  set( TRXTEST_TEST_NAME ${name} )

  # Group in IDE's like Visual Studio
  set_property( TARGET ${ELXTEST_EXECUTABLE_NAME} PROPERTY FOLDER "tests" )

  # Add the test.
  add_test( NAME ${name} COMMAND ${EXECUTABLE_OUTPUT_PATH}/transformix ${ARGN} -out ${output_dir} )
endmacro()

#---------------------------------------------------------------------
# Macro's that simplifies the addition of tests that run elastix
#
# Usage:
# elx_add_run_test( <name_of_test>
#                   IMAGE <name_of_baseline> | METRICVALUE "string"
#                     | CHECKSUM "string"
#                   <elastix_commandline_arguments> )
#

# Get the baseline checksum values file
#
# Ideally, a registration returns exactly the same result, regardless of
# platform, OS and compiler. We observed however, that this is not the case.
# Therefore, for some tests we accept differences between systems, and only
# test for consistency over time for the same system.
#
# To this end we have defined baseline checksum values for several systems.
# The code below checks what the current system is and finds the corresponding
# baseline file. We currently do this by means of the CTEST_SITE and CTEST_BUILD_NAME.
# Different sites can give different results, so we only test the checksum for
# the sites that are known to us, and those are the sites that submit to the
# nightly dashboard. Note that this means that these checksum comparison test
# only work if run via the dashboard scripts.
#
set( knownChecksumSystem false )
set( specializedTransformParameterSystem false )
if( SITE STREQUAL "LKEB.PCMarius"
    AND BUILDNAME STREQUAL "Win7-64bit-VS2010" )
  set( checksumBaselineFile ${TestBaselineDir}/checksums_LKEB.PCMarius_Win7-64bit-VS2010.txt )
  set( knownChecksumSystem true )
  set( specializedTransformParameterSystem true )
elseif( SITE STREQUAL "LKEB.goliath"
    AND BUILDNAME STREQUAL "Linux-64bit-gcc4.6.3-Release" )
  set( checksumBaselineFile ${TestBaselineDir}/checksums_LKEB.goliath_Linux-64bit-gcc4.txt )
  set( knownChecksumSystem true )
  set( specializedTransformParameterSystem true )
elseif( SITE STREQUAL "LKEB.goliath"
    AND BUILDNAME STREQUAL "Linux-clang3.3-Release" )
  set( specializedTransformParameterSystem true )
elseif( SITE STREQUAL "LKEB.MacMini"
    AND BUILDNAME STREQUAL "MacOSX-64bit-gcc4.2.1" )
  set( checksumBaselineFile ${TestBaselineDir}/checksums_LKEB.MacMini_MacOSX-64bit-gcc4.txt )
  set( knownChecksumSystem true )
  set( specializedTransformParameterSystem true )
elseif( SITE STREQUAL "BIGR.PCStefan"
    AND BUILDNAME STREQUAL "WinXP-32bit-VS2008" )
  set( checksumBaselineFile ${TestBaselineDir}/checksums_BIGR.PCStefan_WinXP-32bit-VS2008.txt )
  set( knownChecksumSystem true )
  set( specializedTransformParameterSystem true )
elseif( SITE STREQUAL "BIGR.cluster"
    AND BUILDNAME STREQUAL "Linux-64bit-gcc4.4.6" )
  set( checksumBaselineFile ${TestBaselineDir}/checksums_BIGR.cluster_Linux-64bit-gcc4.txt )
  set( knownChecksumSystem true )
  set( specializedTransformParameterSystem true )
endif()

if( knownChecksumSystem )
  message( STATUS "Checksum baseline file:" ${checksumBaselineFile} )
endif()

# Python script used for comparing elastix output with baseline results
set( pythonfinalmetric ${elastix_SOURCE_DIR}/Testing/elx_compare_finalmetricvalue.py )
set( pythonchecksum   ${elastix_SOURCE_DIR}/Testing/elx_compare_checksum.py )
set( pythonoverlap    ${elastix_SOURCE_DIR}/Testing/elx_compare_overlap.py )
set( pythonlandmarks  ${elastix_SOURCE_DIR}/Testing/elx_compare_landmarks.py )

# Helper macro
macro( list_count listvar value count )
  set( tmplist )
  foreach( tmpvalue ${listvar} )
    if( ${tmpvalue} STREQUAL ${value} )
      list( APPEND tmplist . )
    endif()
  endforeach()
  list( LENGTH tmplist tmpcount )
  set( ${count} ${tmpcount} )
endmacro()

# Main elastix_run add_test macro
macro( elx_add_run_test testbasename howtocompare )
  # Create output directory
  set( testname elastix_run_${testbasename} )
  set( output_dir ${TestOutputDir}/${testname} )
  file( MAKE_DIRECTORY ${output_dir} )

  # ${ARGN} may be the elastix command line arguments, but also
  # an optional baseline value followed by those arguments.
  set( baseline ${ARGV2} )
  set( elastixargs ${ARGN} )
  string( SUBSTRING ${baseline} 0 1 firstelement )
  string( COMPARE EQUAL ${firstelement} "-" firstelementisdash )
  if( NOT ${firstelementisdash} )
    list( REMOVE_AT elastixargs 0 )
  endif()

  # Number of -p's to deduce result.?.mhd
  list_count( "${ARGN}" "-p" countp )
  math( EXPR countp "${countp} - 1" )

  # Run elastix, but only in release mode
  # Set maximum test length to 10 minutes
  add_test( NAME ${testname}_OUTPUT
    CONFIGURATIONS Release
    COMMAND ${EXECUTABLE_OUTPUT_PATH}/elastix
    ${elastixargs} -out ${output_dir} )
  set_tests_properties( ${testname}_OUTPUT
    PROPERTIES TIMEOUT 600 )

  # To compare against a baseline TransformParameters file
  # Baselines have been generated on LKEB, PCMarius, Win7, 64 bit, VS2008
  set( baselineTP ${TestBaselineDir}/TransformParameters_${testbasename}.txt )
  set( testTP ${output_dir}/TransformParameters.${countp}.txt )

  # Temporary hack to get some failing tests working
  # These three tests give different results on different platforms
  # They all seem to be using ASGD and B-splines and (N)MI
  if( specializedTransformParameterSystem )
    if( ( SITE STREQUAL "LKEB.goliath" ) OR (SITE STREQUAL "LKEB.MacMini") OR (SITE STREQUAL "BIGR.cluster") OR (SITE STREQUAL "BIGR.PCStefan") )
      if( ${testbasename} STREQUAL "3DCT_lung.MI.bspline.ASGD.001"
        OR ${testbasename} STREQUAL "3DCT_lung.NMI.bspline.ASGD.001" )
        set( baselineTP ${TestBaselineDir}/TransformParameters_${SITE}_${testbasename}.txt )
      endif()
    endif()
  endif()

  # Thread tests should use the original TransformParameters file as a baseline
  string( FIND ${testbasename} "Threads" found )
  if( NOT found EQUAL -1 )
    string( REGEX REPLACE "(-Threads[0-9]+)" "" baselineTP ${baselineTP} )
  endif()

  # Check which tests have to be run
  string( REGEX MATCHALL "[a-zA-Z]+;|[a-zA-Z]+$" compareaslist "${howtocompare}" )
  list( FIND compareaslist "IMAGE"       compare_image )
  list( FIND compareaslist "METRICVALUE" compare_metricvalue )
  list( FIND compareaslist "PARAMETERS"  compare_tp )
  list( FIND compareaslist "CHECKSUM"    compare_checksum )
  list( FIND compareaslist "OVERLAP"     compare_overlap )
  list( FIND compareaslist "LANDMARKS"   compare_landmarks )

  # Compare elastix output image with baseline image
  if( NOT ${compare_image} EQUAL -1 )
    add_test( NAME ${testname}_COMPARE_IM
      CONFIGURATIONS Release
      COMMAND elxImageCompare
      -base ${baseline}
      -test ${output_dir}/result.${countp}.mhd
      -t 1.0 )
    set_tests_properties( ${testname}_COMPARE_IM
      PROPERTIES DEPENDS  ${testname}_OUTPUT )
  endif()

  # Compare elastix output from IterationInfo with a baseline string
  if( NOT ${compare_metricvalue} EQUAL -1 )
    # Only run when python was found
    if( python_executable )
      # Add comparison test, checking the final metric value and more
      add_test( NAME ${testname}_COMPARE_METRIC
        CONFIGURATIONS Release
        COMMAND ${python_executable} ${pythonfinalmetric}
        -b ${baseline} -d ${output_dir} )
      set_tests_properties( ${testname}_COMPARE_METRIC
        PROPERTIES DEPENDS  ${testname}_OUTPUT )
    endif()
  endif()

  # Compare elastix output using checksum
  if( NOT ${compare_checksum} EQUAL -1 )
    # Only run when python was found and if this is a known system
    if( python_executable AND knownChecksumSystem )
      # Add comparison test, checking the registration checksum
      add_test( NAME ${testname}_COMPARE_CHECKSUM
        CONFIGURATIONS Release
        COMMAND ${python_executable} ${pythonchecksum}
        -f ${checksumBaselineFile} -d ${output_dir} -v )
      set_tests_properties( ${testname}_COMPARE_CHECKSUM
        PROPERTIES DEPENDS  ${testname}_OUTPUT )
    endif()
  endif()

  # Compare elastix output using segmentation overlap
  if( NOT ${compare_overlap} EQUAL -1 )
    # Only run when python was found
    if( python_executable )
      add_test( NAME ${testname}_COMPARE_OVERLAP
        CONFIGURATIONS Release
        COMMAND ${python_executable} ${pythonoverlap}
        -b ${baselineTP} -d ${output_dir} -m ${TestDataDir}/3DCT_lung_followup_mask.mha )
      set_tests_properties( ${testname}_COMPARE_OVERLAP
        PROPERTIES DEPENDS  ${testname}_OUTPUT )
    endif()
  endif()

  # Compare elastix output using landmark distance
  if( NOT ${compare_landmarks} EQUAL -1 )
    # Only run when python was found
    if( python_executable )
      add_test( NAME ${testname}_COMPARE_LANDMARKS
        CONFIGURATIONS Release
        COMMAND ${python_executable} ${pythonlandmarks}
        -b ${baselineTP} -d ${output_dir} -f ${TestDataDir}/3DCT_lung_baseline_landmarks.txt )
      set_tests_properties( ${testname}_COMPARE_LANDMARKS
        PROPERTIES DEPENDS  ${testname}_OUTPUT )
    endif()
  endif()

  # Compare elastix output using transform parameters comparison
  if( NOT ${compare_tp} EQUAL -1 )
    add_test( NAME ${testname}_COMPARE_TP
      CONFIGURATIONS Release
      COMMAND elxTransformParametersCompare
      -base ${baselineTP}
      -test ${testTP}
      -a 1e-3 )
    set_tests_properties( ${testname}_COMPARE_TP
      PROPERTIES DEPENDS  ${testname}_OUTPUT )
  endif()
endmacro()

#---------------------------------------------------------------------

# Create elxImageCompare

=== Common/CUDA/CMakeLists.txt ===
# In order to build elastix with CUDA support we have to enable the following line.
#
# It is a workaround around a problem with the nvcc compiler complaining that the
# command line is to long. By default all ITK include path are also propagated to
# the nvcc compiler. These are really a lot of paths, especially with the modular
# setup in ITK4. In addition, these include paths are not needed, since the CUDA
# kernels do not use anything from the ITK.
# Therefore, we reset the include directories to nothing for this directory:
SET_DIRECTORY_PROPERTIES( PROPERTIES INCLUDE_DIRECTORIES "" )

# Create a CUDA library containing the CUDA resampler.
#
# The compiler flag -ftemplate-depth-50 is by default propagated to the CUDA compiler.
# This, however, generates a compiler warning. We temporarily remove the flag, and add
# it again after CUDA_ADD_LIBRARY.
set( remember_flags ${CMAKE_CXX_FLAGS} )
string( REGEX REPLACE "-ftemplate-depth-50" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}" )
CUDA_ADD_LIBRARY( elastix_cuda cudaResampleImageFilter.cu cudaResampleImageFilter.cuh )
set( CMAKE_CXX_FLAGS ${remember_flags} )

# CUDA include directories are needed
CUDA_INCLUDE_DIRECTORIES( ${CUDA_SDK_ROOT_DIR}/C/common/inc )

# Add some additional options to the nvcc compiler
SET( CUDA_NVCC_FLAGS "--ptxas-options=-v;-use_fast_math;-gencode=arch=compute_11,code=\\\"sm_11,compute_11\\\";-gencode=arch=compute_13,code=\\\"sm_13,compute_13\\\";-gencode=arch=compute_20,code=\\\"sm_20,compute_20\\\"" CACHE STRING "Over original CUDA_NVCC_FLAGS" FORCE )

# Group in IDE's like Visual Studio
SET_PROPERTY( TARGET elastix_cuda PROPERTY FOLDER "libraries" )

#---------------------------------------------------------------------
#
# Try to install the CUDA runtime library
#
#
# A CUDA installation always has a 32 bit and a 64 bit dll.
# The current build may be 32 or 64 bit.
# For linux the library name is stored in CUDA_CUDART_LIBRARY.
# For Windows this variable contains the lib, while we need the dll.

IF( WIN32 )
  # STEP 1: Try to determine if this is a 32 or 64 bit build
  #
  # Depend on CUDA_64_BIT_DEVICE_CODE, which checks
  #   IF( CMAKE_SIZEOF_VOID_P EQUAL 8 ) -> 64 bit, otherwise 32
  SET( systembuild64 ${CUDA_64_BIT_DEVICE_CODE} )


  # STEP 2: Get the full names of the cudart libraries
  #
  # The cudart library can be found under the CUDA_TOOLKIT_ROOT_DIR
  # On my windows machine:
  #   C:/NVIDIA/CUDA/bin/cudart32_30_14.dll
  #   C:/NVIDIA/CUDA/bin64/cudart64_30_14.dll
  # On my Ubuntu linux virtual machine:
  #   /usr/local/cuda/lib/libcudart.so
  #   /usr/local/cuda/lib64/libcudart.so
  # I don't know what the path is on other architectures.

  # Find all files with cudart and the shared library
  # prefix&suffix in the name
  FILE( GLOB_RECURSE cudartlibnames
    ${CUDA_TOOLKIT_ROOT_DIR}/*${CMAKE_SHARED_LIBRARY_PREFIX}cudart*${CMAKE_SHARED_LIBRARY_SUFFIX} )
  # On Windows also cudartemu files exist
  FILE( GLOB_RECURSE cudartemulibnames
    ${CUDA_TOOLKIT_ROOT_DIR}/*${CMAKE_SHARED_LIBRARY_PREFIX}cudartemu*${CMAKE_SHARED_LIBRARY_SUFFIX} )
  # Remove the cudartemu files from the list
  LIST( LENGTH cudartemulibnames noemus )
  IF( NOT ${noemus} EQUAL 0 )
    LIST( REMOVE_ITEM cudartlibnames ${cudartemulibnames} )
  ENDIF()


  # STEP 3: Determine which lib we need to install
  #
  # We decide based on the name of the relative path to the library.
  # On my windows machine:
  #   bin/cudart32_30_14.dll
  #   bin64/cudart64_30_14.dll
  # On my Ubuntu linux virtual machine:
  #   lib/libcudart.so
  #   lib64/libcudart.so
  # So use the rule that if we need 64 bit you have three characters
  # followed by 64, and if we need 32 bit we have three characters
  # followed by /.
  foreach( cudartlib ${cudartlibnames} )
    # Get path relative to CUDA_TOOLKIT_ROOT_DIR
    FILE( RELATIVE_PATH rel_path ${CUDA_TOOLKIT_ROOT_DIR} ${cudartlib} )

    # Get the fourth character
    string( SUBSTRING ${rel_path} 3 1 fourthcharacter )

    # For 64-bit builds assume:
    #   A) three characters followed by "64"
    #   B) ${systembuild64} is TRUE
    IF( ${rel_path} MATCHES "...64" AND ${systembuild64} )
      SET( cudartlibtoinstall ${cudartlib} )
    # For 32-bit builds assume:
    #   A) three characters followed by "/"
    #   B) ${systembuild64} is FALSE
    ELSEIF( ${fourthcharacter} STREQUAL "/" AND NOT ${systembuild64} )
      SET( cudartlibtoinstall ${cudartlib} )
    ENDIF()
  endforeach()

ELSE( WIN32 )
  # If not Windows, assume linux
  # Linux, however, uses symbolic links:
  #   libcudart.so -> libcudart.so.3 -> libcudart.so.3.1.9
  # The last one is the real library that is needed.
  # the linker, however, seems to link against the middle name

  # Get libcudart.so
  SET( cudartlib ${CUDA_CUDART_LIBRARY} )

  # Get libcudart.so.3.1.9 by resolving all symbolic links
  GET_FILENAME_COMPONENT( cudartlibtoinstall ${cudartlib} REALPATH )

  # Get libcudart.so.3, since that is the linked name appearantly
  # Since CUDA 5 it will be libcudart.so.5.0
  file( GLOB cudartlibrenamed ${cudartlib}.? )
  list( LENGTH cudartlibrenamed cudartliblistlength )
  if( ${cudartliblistlength} EQUAL 0 )
    file( GLOB cudartlibrenamed ${cudartlib}.?.? )
  endif()
  GET_FILENAME_COMPONENT( cudartlibrenamed ${cudartlibrenamed} NAME )

ENDIF( WIN32 )


# STEP 4: Install the CUDA runtime library
#
IF( WIN32 )
  INSTALL( FILES ${cudartlibtoinstall}
    DESTINATION . )
    #COMPONENT libraries )
ELSE()
  INSTALL( FILES ${cudartlibtoinstall}
    DESTINATION lib
    #COMPONENT libraries
    #NAMELINK_ONLY )
    RENAME ${cudartlibrenamed} )
ENDIF()

=== Common/KNN/CMakeLists.txt ===
#---------------------------------------------------------------------
PROJECT( KNN )

# Set the files, so that they are shown in the editor
SET( KNN_Files
  itkListSampleCArray.h
  itkListSampleCArray.hxx
  itkANNBinaryTreeCreator.h
  itkANNBinaryTreeCreator.cxx
  itkBinaryTreeBase.h
  itkBinaryTreeBase.hxx
  itkBinaryANNTreeBase.h
  itkBinaryANNTreeBase.hxx
  itkANNkDTree.h
  itkANNkDTree.hxx
  itkANNbdTree.h
  itkANNbdTree.hxx
  itkANNBruteForceTree.h
  itkANNBruteForceTree.hxx
  itkBinaryTreeSearchBase.h
  itkBinaryTreeSearchBase.hxx
  itkBinaryANNTreeSearchBase.h
  itkBinaryANNTreeSearchBase.hxx
  itkANNStandardTreeSearch.h
  itkANNStandardTreeSearch.hxx
  itkANNFixedRadiusTreeSearch.h
  itkANNFixedRadiusTreeSearch.hxx
  itkANNPriorityTreeSearch.h
  itkANNPriorityTreeSearch.hxx
)

# process the sub-directories
ADD_SUBDIRECTORY( ann_1.1 )

# Create the KNN library
ADD_LIBRARY( KNNlib ${KNN_Files} )

# Link it against the necessary libraries.
TARGET_LINK_LIBRARIES( KNNlib ANNlib ${ITK_LIBRARIES} )

# Group in IDE's like Visual Studio
SET_PROPERTY( TARGET KNNlib PROPERTY FOLDER "libraries" )

=== Common/MevisDicomTiff/CMakeLists.txt ===
# include this file in your CMakeLists.txt file using the add_subdirectory command.
PROJECT( MevisDicomTiff )

IF( ELASTIX_USE_MEVISDICOMTIFF )
  ADD_DEFINITIONS( -D_ELASTIX_USE_MEVISDICOMTIFF )
  ADD_LIBRARY( mevisdcmtiff
    itkMevisDicomTiffImageIO.cxx
    itkMevisDicomTiffImageIOFactory.cxx
    itkUseMevisDicomTiff.cxx
  )
ELSE()
  # avoid dependencies, but compile the lib, so that customers of this 
  # lib can just call RegisterMevisDicomTiff without checking.
  ADD_LIBRARY( mevisdcmtiff
    itkUseMevisDicomTiff.cxx
  )
ENDIF()

TARGET_LINK_LIBRARIES( mevisdcmtiff ${ITK_LIBRARIES} )

# Group in IDE's like Visual Studio
SET_PROPERTY( TARGET mevisdcmtiff PROPERTY FOLDER "libraries" )

# add mevisdcmtiff to the list of target_link_libraries in your cmakelists.txt file.

=== Common/ParameterFileParser/CMakeLists.txt ===
# Sources of non-templated classes.
SET( param_SRCS
  itkParameterFileParser.h
  itkParameterFileParser.cxx
  itkParameterMapInterface.h
  itkParameterMapInterface.cxx
)

SOURCE_GROUP( "Parser" FILES ${param_SRCS} )

ADD_LIBRARY( param ${param_SRCS} )

TARGET_LINK_LIBRARIES( param ${ITK_LIBRARIES} )

# Group in IDE's like Visual Studio
SET_PROPERTY( TARGET param PROPERTY FOLDER "libraries" )

=== Core/Install/CMakeLists.txt ===
#
# This CMakeLists file will generate the file elxSupportedImageTypes.h
# in the bin directory. This file defines the types of images for which
# elastix is compiled.
#

# User specified variables:
mark_as_advanced( ELASTIX_IMAGE_DIMENSIONS )
set( ELASTIX_IMAGE_DIMENSIONS 2 3 4
  CACHE STRING "Specify image dimensions" )

mark_as_advanced( ELASTIX_IMAGE_2D_PIXELTYPES )
set( ELASTIX_IMAGE_2D_PIXELTYPES "float"
  CACHE STRING "Specify 2D pixel types" )

mark_as_advanced( ELASTIX_IMAGE_3D_PIXELTYPES )
set( ELASTIX_IMAGE_3D_PIXELTYPES "short" "float"
  CACHE STRING "Specify 3D pixel types" )

mark_as_advanced( ELASTIX_IMAGE_4D_PIXELTYPES )
set( ELASTIX_IMAGE_4D_PIXELTYPES "short"
  CACHE STRING "Specify 4D pixel types" )

# Define supported dimensions and types for sanity checks.
# Gives protection against typo's.
set( supportedDimensions 2 3 4 )
set( supportedTypes "char" "unsigned char"
  "short" "unsigned short" "int" "unsigned int"
  "long" "unsigned long" "float" "double" )

# Sanity check if > 0 number of dimensions are requested
list( LENGTH ELASTIX_IMAGE_DIMENSIONS numDims )
if( ${numDims} EQUAL 0 )
  message( FATAL_ERROR "ERROR: you should set one or more values "
    " to ELASTIX_IMAGE_DIMENSIONS!\n"
    "Choose a subset of {${supportedDimensions}}." )
endif()

# Start a string containing the supported image types
# and initialize some variables.
set( supportString "" )
set( index 1 )
set( numSupported 0 )

# Add supported image types to the string
foreach( dim ${ELASTIX_IMAGE_DIMENSIONS} )

  # Check dimension
  if( ${dim} EQUAL 2 )
    set( pixelTypeList ${ELASTIX_IMAGE_2D_PIXELTYPES} )
    set( whichList "ELASTIX_IMAGE_2D_PIXELTYPES" )
  elseif( ${dim} EQUAL 3 )
    set( pixelTypeList ${ELASTIX_IMAGE_3D_PIXELTYPES} )
    set( whichList "ELASTIX_IMAGE_3D_PIXELTYPES" )
  elseif( ${dim} EQUAL 4 )
    set( pixelTypeList ${ELASTIX_IMAGE_4D_PIXELTYPES} )
    set( whichList "ELASTIX_IMAGE_4D_PIXELTYPES" )
  else()
    message( FATAL_ERROR "ERROR: you selected ELASTIX_IMAGE_DIMENSIONS"
      " to include ${dim}, which is not supported!\n"
      "Choose a subset of {${supportedDimensions}}." )
  endif()

  # Sanity check if > 0 number of pixel types are requested
  list( LENGTH pixelTypeList pixelTypeListLength )
  if( ${pixelTypeListLength} EQUAL 0 )
    message( FATAL_ERROR "ERROR: you should set one or more values"
      " to ${whichList}!\n"
      "Choose a subset of {${supportedTypes}}." )
  endif()

  # Add types
  foreach( type ${pixelTypeList} )
    # Sanity check
    list( FIND supportedTypes ${type} foundIndex )
    if( ${foundIndex} EQUAL -1 )
      message( FATAL_ERROR "ERROR: you selected ${whichList}"
        " to include ${type}, which is not supported!\n"
        "Choose a subset of {${supportedTypes}}." )
    endif()

    # Add type to supportString
    set( supportString
      "${supportString}  elxSupportedImageTypeMacro( ${type}, ${dim}, ${type}, ${dim}, ${index} );\n" )

    # Increase some variables
    math( EXPR index "${index} + 1" )
    math( EXPR numSupported "${numSupported} + 1" )
  endforeach()
endforeach()

# Prepend the string with the number of supported images.
set( supportString
  "const unsigned int NrOfSupportedImageTypes = ${numSupported};\n\n${supportString}" )

# Put the generated string in the elxSupportedImageTypes.h
# header using configure_file.
set( UserDefinedSupportedImageTypes ${supportString} )
configure_file(
  ${elastix_SOURCE_DIR}/Core/Install/elxSupportedImageTypes.h.in
  ${elastix_BINARY_DIR}/elxSupportedImageTypes.h
  @ONLY )

=== Common/KNN/ann_1.1/CMakeLists.txt ===
PROJECT( ANN )

# Compile time option to select wheter or not to accept self matches
# during nearest neighbour search. The default is false for backward
# compatibility.
mark_as_advanced( ELASTIX_KNN_ALLOW_SELF_MATCH )
set( ELASTIX_KNN_ALLOW_SELF_MATCH false
  CACHE BOOL "Allow self matches during kNN search" )
set( ANN_ALLOW_SELF_MATCH "ANNfalse" )
if( ${ELASTIX_KNN_ALLOW_SELF_MATCH} )
  set( ANN_ALLOW_SELF_MATCH "ANNtrue" )
endif()
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/include/ANN/ANN.h.in
  ${elastix_BINARY_DIR}/ANN/ANN.h
  @ONLY )

# Include these directories to look for header files.
INCLUDE_DIRECTORIES(
  ${ANN_SOURCE_DIR}/include
  ${ANN_SOURCE_DIR}/src
)

# Sources of non-templated classes.
SET( ANN_SRCS
  src/ANN.cpp
  src/bd_fix_rad_search.cpp
  src/bd_pr_search.cpp
  src/bd_search.cpp
  src/bd_tree.cpp
  src/brute.cpp
  src/kd_dump.cpp
  src/kd_fix_rad_search.cpp
  src/kd_pr_search.cpp
  src/kd_search.cpp
  src/kd_split.cpp
  src/kd_tree.cpp
  src/kd_util.cpp
  src/perf.cpp
)

# Create the ANNlib library
ADD_LIBRARY( ANNlib SHARED ${ANN_SRCS} )

# Necessary, because in windows dll_export is needed for creating the
# dll, but dll_import for using it in a program.
SET_TARGET_PROPERTIES( ANNlib PROPERTIES DEFINE_SYMBOL DLL_EXPORTS )

# Group in IDE's like Visual Studio
SET_PROPERTY( TARGET ANNlib PROPERTY FOLDER "libraries" )

# Install
IF( WIN32 )
  INSTALL( TARGETS ANNlib
    RUNTIME DESTINATION .
    LIBRARY DESTINATION . )
    #COMPONENT libraries )
ELSE()
  INSTALL( TARGETS ANNlib
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib )
    #COMPONENT libraries )
ENDIF()

=== Components/Metrics/KNNGraphAlphaMutualInformation/CMakeLists.txt ===

ADD_ELXCOMPONENT( KNNGraphAlphaMutualInformationMetric
 elxKNNGraphAlphaMutualInformationMetric.h
 elxKNNGraphAlphaMutualInformationMetric.hxx
 elxKNNGraphAlphaMutualInformationMetric.cxx
 itkKNNGraphAlphaMutualInformationImageToImageMetric.h
 itkKNNGraphAlphaMutualInformationImageToImageMetric.hxx
)

IF( USE_KNNGraphAlphaMutualInformationMetric )
  TARGET_LINK_LIBRARIES( KNNGraphAlphaMutualInformationMetric KNNlib ANNlib )
ENDIF()

=== debian/changelog ===
elastix (4.7-2) unstable; urgency=medium

  * Build-Depends: libfftw3-dev
    Closes: #746089

 -- Andreas Tille <tille@debian.org>  Sun, 27 Apr 2014 17:54:59 +0200

elastix (4.7-1) unstable; urgency=medium

  [ Gert Wollny ]
  * New upstream version
  * Add --as-needed to the linker flags
  * remove patches/disable-mevisdicomtiff.patch, fixed upstream (91edb5)
  * remove patches/itk-review-detection.patch, fixed upstream (9442a2)
  * Add patch to disable google-adsense in the created documentation  

  [ Andreas Tille ]
  * cme fix dpkg-control
  * Provide doc-base file

 -- Gert Wollny <gw.fossdev@gmail.com>  Tue, 11 Mar 2014 11:32:25 +0100

elastix (4.6-2) unstable; urgency=low

  * patches/itk-review-detection.patch: New.  Update ITK "Review module"
    detection to be compatible with ITK 4.5.
  * control: Tighten ITK build dep to be 4.5.0-2 because -1 omitted the
    review module.  Add libdcmtk2-dev, now required by ITK.

 -- Steve M. Robbins <smr@debian.org>  Sat, 04 Jan 2014 17:48:12 -0600

elastix (4.6-1) unstable; urgency=low

  * New upstream version.
  * control: Build-depend on libinsighttoolkit4-dev (instead of ITK 3).
  * control(elastix): Build only architectures amd64 and i386, following ITK 4.

  * patches/disable-mevisdicomtiff.patch: New.  Fix build system to honour
    ELASTIX_USE_MEVISDICOMTIFF=false
  * rules: Build with ELASTIX_USE_MEVISDICOMTIFF=false.
  
  * control: Add build-dep-indep on texlive-fonts-recommended to build
    docs.  Remove build-dep on libgdcm2-dev.  Closes: #731921.

 -- Steve M. Robbins <smr@debian.org>  Fri, 13 Dec 2013 23:26:15 -0600

=== debian/control ===
Source: elastix
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>,
           Andreas Tille <tille@debian.org>,
           Gert Wollny <gw.fossdev@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libinsighttoolkit4-dev,
               libdcmtk2-dev,
               zlib1g-dev,
               libpng-dev,
               libtiff-dev,
               libfftw3-dev
Build-Depends-Indep: doxygen,
                     graphviz,
                     texlive-latex-base,
                     texlive-latex-extra,
                     texlive-latex-recommended,
                     texlive-fonts-recommended,
                     ghostscript,
                     latex-xcolor
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/elastix/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/elastix/trunk/
Homepage: http://elastix.isi.uu.nl/

Package: elastix
Architecture: amd64 i386
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: elastix-doc
Description: toolbox for rigid and nonrigid registration of images
 Image registration based on the well-known Insight Segmentation and
 Registration Toolkit (ITK). The software consists of a collection of
 algorithms that are commonly used to solve (medical) image
 registration problems. The modular design of elastix allows the user
 to quickly configure, test, and compare different registration
 methods for a specific application. A command-line interface enables
 automated processing of large numbers of data sets, by means of
 scripting.

Package: elastix-doc
Architecture: all
Section: doc
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: toolbox for rigid and nonrigid registration of images - docs
 Image registration based on the well-known Insight Segmentation and
 Registration Toolkit (ITK). The software consists of a collection of
 algorithms that are commonly used to solve (medical) image
 registration problems. The modular design of elastix allows the user
 to quickly configure, test, and compare different registration
 methods for a specific application. A command-line interface enables
 automated processing of large numbers of data sets, by means of
 scripting.
 .
 This package contains the elastix documentation.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --sourcedirectory=src

binary: binary-arch binary-indep

binary-indep: doc-stamp
	dh $@ --sourcedirectory=src --parallel


# Need -DUSE_KNNGraphAlphaMutualInformationMetric:BOOL=ON, otherwise
# KNN is not built, and link of elastix fails.
#
DEB_CMAKE_EXTRA_FLAGS += \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_BUILD_TYPE=RELEASE \
	-DCMAKE_SKIP_RPATH=ON \
	-DELASTIX_USE_MEVISDICOMTIFF:BOOL=OFF \
	-DUSE_KNNGraphAlphaMutualInformationMetric:BOOL=ON

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)

override_dh_builddeb:
	dh_builddeb -- -Z xz

doc: doc-stamp

doc-stamp: help/html/index.html dox/manual/manual.pdf
	touch $@

# build-deps: doxygen, latex, dot
help/html/index.html: help/doxyfile.out
	doxygen $<

dox/manual/manual.pdf: dox/manual/manual.tex
	cd dox/manual && latex manual && latex manual && dvipdf manual
